/*
 * Docs Dispatcher API - API document(s) generation
 * Docs.io API enables you to generate files (currently DOCx, XLSx, PPTx, PDF, HTML, JPG/PNG/SVG) from a template and JSON data. You can just download resulting file, send email with generated attachments or compose services.
 *
 * The version of the OpenAPI document: 3.1.1
 * Contact: tech@docs-dispatcher.io
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package io.docs_dispatcher.client.model;

import java.util.Objects;
import com.google.gson.annotations.SerializedName;

import java.io.IOException;
import com.google.gson.TypeAdapter;
import com.google.gson.JsonElement;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;

/**
 * Gets or Sets Service
 */
@JsonAdapter(Service.Adapter.class)
public enum Service {
  
  EMAIL("email"),
  
  FILE("file"),
  
  SMS("sms"),
  
  POSTAL("postal"),
  
  UPLOAD("upload"),
  
  ESIGN("esign");

  private String value;

  Service(String value) {
    this.value = value;
  }

  public String getValue() {
    return value;
  }

  @Override
  public String toString() {
    return String.valueOf(value);
  }

  public static Service fromValue(String value) {
    for (Service b : Service.values()) {
      if (b.value.equals(value)) {
        return b;
      }
    }
    throw new IllegalArgumentException("Unexpected value '" + value + "'");
  }

  public static class Adapter extends TypeAdapter<Service> {
    @Override
    public void write(final JsonWriter jsonWriter, final Service enumeration) throws IOException {
      jsonWriter.value(enumeration.getValue());
    }

    @Override
    public Service read(final JsonReader jsonReader) throws IOException {
      String value = jsonReader.nextString();
      return Service.fromValue(value);
    }
  }

  public static void validateJsonElement(JsonElement jsonElement) throws IOException {
    String value = jsonElement.getAsString();
    Service.fromValue(value);
  }
}

